diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/ls.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/ls.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/ls.c	2005-12-31 21:57:37.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/ls.c	2006-08-01 00:46:41.796566000 +0900
@@ -41,6 +41,7 @@
 #include "cadaver.h"
 #include "basename.h"
 #include "utils.h"
+#include "codeconv.h"
 
 struct fetch_context {
     struct resource **list;
@@ -92,7 +93,7 @@
 static void display_ls_line(struct resource *res)
 {
     const char *restype;
-    char exec_char, vcr_char, *name;
+    char exec_char, vcr_char, *name, *pt;
 
     switch (res->type) {
     case resr_normal: restype = ""; break;
@@ -115,15 +116,17 @@
     name = ne_path_unescape(name);
 
     if (res->type == resr_error) {
-	printf(_("Error: %-30s %d %s\n"), name, res->error_status,
+	printf(_("Error: %-30s %d %s\n"), (pt = fromUTF8(name)), res->error_status,
 	       res->error_reason?res->error_reason:_("unknown"));
+	free(pt);
     } else {
 	exec_char = res->is_executable ? '*' : ' ';
 	/* 0: no vcr, 1: checkin, 2: checkout */
 	vcr_char = res->is_vcr==0 ? ' ' : (res->is_vcr==1? '>' : '<');
 	printf("%5s %c%c%-29s %10d  %s\n", 
-	       restype, vcr_char, exec_char, name,
+	       restype, vcr_char, exec_char, (pt = fromUTF8(name)),
 	       res->size, format_time(res->modtime));
+	free(pt);
     }
 
     free(name);
@@ -132,11 +135,12 @@
 void execute_ls(const char *remote)
 {
     int ret;
-    char *real_remote;
+    char *real_remote, *pt;
     struct resource *reslist = NULL, *current, *next;
 
     if (remote != NULL) {
-	real_remote = resolve_path(session.uri.path, remote, true);
+	real_remote = resolve_path(session.uri.path, pt = toUTF8(remote), true);
+	free(pt);
     } else {
 	real_remote = ne_strdup(session.uri.path);
     }
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/options.c cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/options.c
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/options.c	2004-10-11 05:53:02.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/options.c	2006-08-01 00:53:37.263979000 +0900
@@ -39,6 +39,7 @@
 #include "common.h"
 #include "cadaver.h"
 #include "options.h"
+#include "codeconv.h"
 
 static void set_debug(const char *new);
 static void unset_debug(const char *new);
@@ -58,7 +59,7 @@
 
 /* Option holders */
 
-static int enable_expect, presume_utf8, overwrite, quiet, searchall;
+static int enable_expect, overwrite, quiet, searchall;
 
 enum ne_lock_scope lockscope;
 int lockdepth;
@@ -89,7 +90,6 @@
     B(tolerant, &tolerant, "Tolerate non-WebDAV collections"),
     B(overwrite, &overwrite, "Enable overwrite (e.g. on copy/move operations"),
     B(expect100, &enable_expect, "Enable use of 'Expect: 100-continue' header"),
-    B(utf8, &presume_utf8, "Presume filenames etc are UTF-8 encoded"),
     B(quiet, &quiet, "Whether to display connection status messages"),
     B(searchall, &searchall, "Whether to search and display all props including dead props"),
 #undef B
@@ -102,6 +102,9 @@
        "Client certificate to use for SSL connections."),
     S(namespace, "Namespace to use for propset/propget commands."),
     S(pager, "Command to run for less/more commands."),
+#ifdef HAVE_ICONV
+    S(localcharset, "Local characterset (remote: UTF-8)"),
+#endif
     S(proxy, "Hostname of proxy server"),
     S(searchorder,  "Search ascending props options"),
     S(searchdorder, "Search descending props options"),
@@ -358,6 +361,9 @@
 		    }
 		    break;
 		}
+#ifdef HAVE_ICONV
+		if (options[n].id == opt_localcharset) seticonv(newv);
+#endif
 		return;
 	    }
 	}
@@ -392,6 +398,9 @@
 		(*options[n].unset)(newv);
 		break;
 	    }
+#ifdef HAVE_ICONV
+	    if (options[n].id == opt_localcharset) seticonv(newv);
+#endif
 	    return;
 	}
     }
@@ -440,6 +449,7 @@
     for (n = 0; options[n].name != NULL; n++) {
 	if (options[n].id == id) {
 	    options[n].holder = newval;
+	    if (id == opt_localcharset) seticonv(newval);
 	    return;
 	}
     }
diff -urN cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/options.h cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/options.h
--- cadaver-0.22.3-1-orig/src/cadaver-0.22.3/src/options.h	2004-10-11 05:53:02.000000000 +0900
+++ cadaver-0.22.3-1-i18n/src/cadaver-0.22.3/src/options.h	2006-08-01 00:54:19.474675000 +0900
@@ -32,7 +32,9 @@
     opt_proxy,
     opt_proxy_port,
     opt_debug,
-    opt_utf8,
+#ifdef HAVE_ICONV
+    opt_localcharset,
+#endif
     opt_overwrite,
     opt_lockowner,
     opt_lockstore,
